%This Example for using users m-function problem_st_dev_risk_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%for {matrix_fact_in; matrix_fact_out; num} = crossvalidation(10, matrix_scenarios)
%
%minimize 
%st_dev(matrix_fact_in)
%value: 
%l_num(matrix_fact_out) 
%l_num(matrix_fact_in)
%cvar_dev(0.9, matrix_fact_in) meanabs_dev(matrix_fact_in)
%st_dev(matrix_fact_in)
%var_risk(0.75, matrix_fact_in)
%var_risk_g(0.75, matrix_fact_in)
%var_risk(0.9, matrix_fact_in)
%var_risk_g(0.9, matrix_fact_in)    
%end for                                                                           
%
%Input variables:
%
%Inputs                        PSG Type    PSG Object          Location in Problem Statement                                                         Class
%matrix_scenarios_benchmark    bench       matrix_scenarios    for {matrix_fact_in; matrix_fact_out; num} = crossvalidation(10, matrix_scenarios)    double
%matrix_scenarios_data         data        matrix_scenarios    for {matrix_fact_in; matrix_fact_out; num} = crossvalidation(10, matrix_scenarios)    double
%matrix_scenarios_vars         vars        matrix_scenarios    for {matrix_fact_in; matrix_fact_out; num} = crossvalidation(10, matrix_scenarios)    cell
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('C:\Aorda\PSG\MATLAB\CS_Mortgage_Pipeline_Hedging\05_15_2019\problem_st_dev_risk\problem_st_dev_risk_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function problem_st_dev_risk_subroutine:

[solution_str,outargstruc_arr] = problem_st_dev_risk_subroutine(matrix_scenarios_benchmark,matrix_scenarios_data,matrix_scenarios_vars);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2019.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
